/// <reference types="react" />
import { DataType, ErrorMessages, Props, RegisterInput, OnSubmit } from './types';
export default function useForm<Data extends DataType>({ mode, validationSchema, defaultValues, validationFields }?: Props<Data>): {
    register: (refOrValidateRule: any, validateRule?: RegisterInput | undefined) => ((ref: any) => void) | undefined;
    handleSubmit: (callback: OnSubmit<Data>) => (e: import("react").SyntheticEvent<Element, Event>) => Promise<void>;
    watch: (fieldNames?: string | string[] | undefined, defaultValue?: string | Partial<Data> | undefined) => any;
    unSubscribe: () => void;
    reset: () => void;
    setError: <Name extends keyof Data>(name: Extract<Name, string>, type: string, message?: string | undefined, ref?: any) => void;
    setValue: <Name extends keyof Data>(name: Extract<Name, string>, value: Data[Name], shouldRender?: boolean) => void;
    triggerValidation: <Name extends keyof Data>({ name, value, forceValidation, }: {
        name: Extract<keyof Data, string>;
        value?: Data[Name] | undefined;
        forceValidation?: boolean | undefined;
    }) => Promise<boolean>;
    getValues: () => {
        [key: string]: any;
    };
    errors: ErrorMessages<Data>;
    formState: {
        dirty: boolean;
        isSubmitted: boolean;
        submitCount: number;
        touched: string[];
        isSubmitting: boolean;
    };
};
